; equates
; DISPLAY LIST EQUATES
; 
ADLI        equ $0080
AVB         equ $0040
ALMS        equ $0040
AVSCR       equ $0020
AHSCR       equ $0010
AJMP        equ $0001
AEMPTY1     equ $0000
AEMPTY2     equ $0010
AEMPTY3     equ $0020
AEMPTY4     equ $0030
AEMPTY5     equ $0040
AEMPTY6     equ $0050
AEMPTY7     equ $0060
AEMPTY8     equ $0070

SDLSTL      equ $0230
SDLSTH      equ $0231

COLOR0      equ $02C4
COLOR1      equ $02C5
COLOR2      equ $02C6
COLOR3      equ $02C7
COLOR4      equ $02C8

WSYNC       equ $D40A
VCOUNT      equ $D40B
NMIEN       equ $D40E
VDSLST      equ $0200
CONSOL      equ $D01F

COLDSV      equ $E477
SETVBV      equ $E45C
SYSVBV      equ $E45F

SKCTL       equ $D20F ; ?

HSCROL      equ $D404
COLPF3      equ $D019

	org $2000
	ins "t6000.bin"
	ins "t6800.bin"
:80 dta 0
start

            lda #<L9034 ; $34               ; A9 34
            sta SDLSTL             ; 8D 30 02
            lda #>L9034 ; $90               ; A9 90
            sta SDLSTH             ; 8D 31 02

            lda #$00               ; A9 00
            sta COLOR4             ; 8D C8 02
            lda #$04               ; A9 04
            sta COLOR0             ; 8D C4 02
            lda #$08               ; A9 08
            sta COLOR1             ; 8D C5 02
            lda #$0C               ; A9 0C
            sta COLOR2             ; 8D C6 02

            lda #$C0               ; A9 C0
            sta NMIEN              ; 8D 0E D4

            lda #<L9000 ; $00               ; A9 00
            sta VDSLST             ; 8D 00 02
            lda #>L9000 ; $90               ; A9 90
            sta VDSLST+1           ; 8D 01 02

            jsr L39C6              ; 20 C6 39
L39B6       lda CONSOL             ; AD 1F D0
            cmp #$03               ; C9 03
            bne L39B6              ; D0 F9
            jmp COLDSV             ; 4C 77 E4

L39C6       lda #$03               ; A9 03
;            sta SKCTL              ; 8D 0F D2
;            sta L40F1              ; 8D F1 40
;            lda #$00               ; A9 00
;            sta AUDCTL             ; 8D 08 D2
;            sta L40EA              ; 8D EA 40
;            sta L40E7              ; 8D E7 40
;            sta L40DE              ; 8D DE 40
;            sta L40E6              ; 8D E6 40
;            sta L40E1              ; 8D E1 40
;            sta L40DF              ; 8D DF 40
;            sta L40E0              ; 8D E0 40
;            sta L40ED              ; 8D ED 40
;            sta L40E1              ; 8D E1 40
;            sta L40EC              ; 8D EC 40
;            sta L40EB              ; 8D EB 40
;            sta L40F3              ; 8D F3 40

;https://atariwiki.org/wiki/Wiki.jsp?page=SETVBV
;X	MSB
;Y	LSB
;A	vector to be changed, see below
;Value	Vector
;0	VIMIRQ
;1	TIMCOUNT1
;2	TIMCOUNT2
;3	TIMCOUNT3
;4	TIMCOUNT4
;5	TIMCOUNT5
;6	VVBLKI
;7	VVBLKD


            ldx #>L9103 ; $91               ; A2 91
            ldy #<L9103 ; $03               ; A0 03
            lda #$06               ; A9 06
            jsr SETVBV             ; 20 5C E4
            lda #$C0               ; A9 C0
            sta NMIEN              ; 8D 0E D4
            rts                    ; 60

; vblank
L8D00	dta 0
L9103
            dec L8D00              ; CE 00 8D
            lda L8D00              ; AD 00 8D
            sta HSCROL             ; 8D 04 D4
            bpl L9145              ; 10 37
            lda #$07               ; A9 07
            sta L8D00              ; 8D 00 8D
            sta HSCROL             ; 8D 04 D4
            inc L9036              ; EE 36 90
            bne L911E              ; D0 03
            inc L9036+1 ; L9037              ; EE 37 90
L911E       inc L90FD              ; EE FD 90
            bne L9126              ; D0 03
            inc L90FD+1 ; L90FE              ; EE FE 90
L9126       nop                    ; EA
            nop                    ; EA
            nop                    ; EA
            nop                    ; EA
            nop                    ; EA
            nop                    ; EA
            nop                    ; EA
            lda L9036+1 ; lda L9037              ; AD 37 90
            cmp #$28               ; C9 68
            bne L9139              ; D0 05
            lda #$20               ; A9 60
            sta L9036+1 ; sta L9037              ; 8D 37 90
L9139       lda L90FD+1 ; L90FE              ; AD FE 90
            cmp #$2C               ; C9 6C
            bne L9145              ; D0 05
            lda #$28               ; A9 68
            sta L90FD+1 ; L90FE              ; 8D FE 90
L9145      jmp SYSVBV             ; 4C 5F E4

; Display List Interrupt
L9000       pha                    ; 48
            txa                    ; 8A
            pha                    ; 48
            ldx #$00               ; A2 00
L9005       lda L9017,X            ; BD 17 90
            sta WSYNC              ; 8D 0A D4
            sta COLPF3             ; 8D 19 D0
            inx                    ; E8
            cpx #$10               ; E0 10
            bne L9005              ; D0 F2
            pla                    ; 68
            txa                    ; 8A
            pla                    ; 68
            rti                    ; 40
L9017       dta $02,$02,$04,$06,$08,$0A,$0C,$0E
            dta $0E,$0C,$0A,$08,$06,$04,$02,$02
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00

L9034       dta ADLI+AEMPTY1
            dta AHSCR+ALMS+$07
L9036       dta a($2000)
            dta ADLI+AEMPTY2
            dta ALMS+$0E
            dta a($9150)
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E
            dta ALMS+$0E
            dta a($A000)
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta $0E,$0E,$0E,$0E,$0E,$0E,$0E
            dta ADLI+AEMPTY6
            dta AHSCR+ALMS+$07
L90FD       dta a($2800)
            dta ADLI+AEMPTY1
            dta AVB+AJMP
            dta a(L9034)

	run start
